%{?!module_name: %{error: You did not specify a module name (%%module_name)}}
%{?!version: %{error: You did not specify a module version (%%version)}}
%{?!kernel_versions: %{error: You did not specify kernel versions (%%kernel_version)}}
%{?!packager: %define packager DKMS <dkms-devel@lists.us.dell.com>}
%{?!license: %define license Unknown}
%{?!_dkmsdir: %define _dkmsdir /var/lib/dkms}
%{?!_srcdir: %define _srcdir %_prefix/src}
%{?!_datarootdir: %define _datarootdir %{_datadir}}

Summary:	%{module_name} %{version} dkms package
Name:		%{module_name}
Version:	%{version}
License:	%license
Release:	1dkms
BuildArch:	x86_64
Group:		System/Kernel
Requires: 	dkms >= 1.95
BuildRequires: 	dkms
BuildRoot: 	%{_tmppath}/%{name}-%{version}-%{release}-root/

%description
Kernel modules for %{module_name} %{version} in a DKMS wrapper.

%prep
if [ "%mktarball_line" != "none" ]; then
        /usr/sbin/dkms mktarball -m %module_name -v %version %mktarball_line --archive `basename %{module_name}-%{version}.dkms.tar.gz`
        cp -af %{_dkmsdir}/%{module_name}/%{version}/tarball/`basename %{module_name}-%{version}.dkms.tar.gz` %{module_name}-%{version}.dkms.tar.gz
fi

%pre
lsmod | grep -q %module_name
if [ $? == 0 ]; then
        echo "" 
        echo "WARNING: pls reboot to take the new driver effect after the installation is complete, because old version module has been running!"
        echo "" 
fi

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
        rm -rf $RPM_BUILD_ROOT
fi
mkdir -p $RPM_BUILD_ROOT/%{_srcdir}
mkdir -p $RPM_BUILD_ROOT/%{_datarootdir}/%{module_name}

if [ -d %{_sourcedir}/%{module_name}-%{version} ]; then
        cp -Lpr %{_sourcedir}/%{module_name}-%{version} $RPM_BUILD_ROOT/%{_srcdir}
fi

if [ -f %{module_name}-%{version}.dkms.tar.gz ]; then
        install -m 644 %{module_name}-%{version}.dkms.tar.gz $RPM_BUILD_ROOT/%{_datarootdir}/%{module_name}
fi

if [ -f %{_sourcedir}/common.postinst ]; then
        install -m 755 %{_sourcedir}/common.postinst $RPM_BUILD_ROOT/%{_datarootdir}/%{module_name}/postinst
fi

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
        rm -rf $RPM_BUILD_ROOT
fi

%post
if [ $1 == 1 ];then
        if [ ! -d /lib/firmware/vastai ]; then
                mkdir -p /lib/firmware/vastai
        else
                echo "direction already exist"
        fi

        echo -e "%{_srcdir}/%{module_name}-%{version} cp in post"
        for BIN_NAME in vastai_bl1.bin vastai_bmcu.bin vastai_bl0.bin vastai_fw.bin; do
                if [ -f %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME ]; then
                        cp %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME /lib/firmware/vastai
                else
                        echo -e "WARNING: can't find $BIN_NAME in for"
                fi
        done

        if [ -f %{_srcdir}/%{module_name}-%{version}/vastai.rules ]; then
                install -m 644 %{_srcdir}/%{module_name}-%{version}/vastai.rules /etc/udev/rules.d/
                echo "install udev rules done"
        else
                echo "ERROR: find file %{_srcdir}/%{module_name}-%{version}/vastai.rules fail!"
                exit 1
        fi

        for POSTINST in %{_prefix}/lib/dkms/common.postinst %{_datarootdir}/%{module_name}/postinst; do
                if [ -f $POSTINST ]; then
                        findResult=$(find /lib/modules -name vastai_pci.ko*)
                        if [[ ${findResult} != "" ]]; then
                                rm ${findResult}
                        else
                                echo "file already remove"
                        fi
                        $POSTINST %{module_name} %{version} %{_datarootdir}/%{module_name}
                        if [ $? != 0 ]; then
                                echo "ERROR: installation failed!"
                                exit 1
                        fi
                        udevadm control --reload
                        udevadm trigger --action=add
                        exit 0
                fi
                echo "WARNING: $POSTINST does not exist."
        done
        echo -e "ERROR: DKMS version is too old and %{module_name} was not"
        echo -e "built with legacy DKMS support."
        echo -e "You must either rebuild %{module_name} with legacy postinst"
        echo -e "support or upgrade DKMS to a more current version."
        exit 1

elif [ $1 == 2 ];then
        string=%{module_name}
        rmmod $(echo ${string:0:10})
        if [ $? -eq 0 ]; then
                echo "[Upgrade] Old driver uninstalled successfully"
        else
                echo "[Upgrade] Old driver uninstall failed"
        fi

        rm -rf /lib/firmware/vastai
        if [ $? -eq 0 ]; then
                echo "[Upgrade] Remove old directory /lib/firmware/vastai"
        else
                echo "[Upgrade] Old direction /lib/firmware/vastai removal failed"
        fi

        findResult=$(find /lib/modules -name vastai_pci.ko*)
        if [[ ${findResult} != "" ]]; then
                rm ${findResult}
                echo "[Upgrade] Remove old file ${findResult}"
        else
                echo "[Upgrade] Old file ${findResult} has been removed"
        fi

        if [ ! -d /lib/firmware/vastai ]; then
                mkdir -p /lib/firmware/vastai
                echo "[Upgrade] Create directory /lib/firmware/vastai"
        else
                echo "[Upgrade] /lib/firmware/vastai direction already exist"
        fi

        echo -e "[Upgrade] %{_srcdir}/%{module_name}-%{version} cp in post"
        for BIN_NAME in vastai_bl1.bin vastai_bmcu.bin vastai_bl0.bin vastai_fw.bin; do
                if [ -f %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME ]; then
                        cp %{_srcdir}/%{module_name}-%{version}/fw/$BIN_NAME /lib/firmware/vastai
                else
                        echo -e "[Upgrade] WARNING: can't find $BIN_NAME in for"
                fi
        done

        if [ -f %{_srcdir}/%{module_name}-%{version}/vastai.rules ]; then
                install -m 644 %{_srcdir}/%{module_name}-%{version}/vastai.rules /etc/udev/rules.d/
                echo "[Upgrade] install udev rules done"
        else
                echo "[Upgrade] ERROR: find file %{_srcdir}/%{module_name}-%{version}/vastai.rules fail!"
                exit 1
        fi

        for POSTINST in %{_prefix}/lib/dkms/common.postinst %{_datarootdir}/%{module_name}/postinst; do
                if [ -f $POSTINST ]; then
                        findResult=$(find /lib/modules -name vastai_pci.ko*)
                        if [[ ${findResult} != "" ]]; then
                                rm ${findResult}
                        else
                                echo "[Upgrade] file ${findResult} has been removed"
                        fi
                        $POSTINST %{module_name} %{version} %{_datarootdir}/%{module_name}
                        if [ $? != 0 ]; then
                                echo "[Upgrade] ERROR: installation failed!"
                                exit 1
                        fi
                        udevadm control --reload
                        udevadm trigger --action=add
                        exit 0
                fi
                echo "[Upgrade] WARNING: $POSTINST does not exist."
        done
        echo -e "[Upgrade] ERROR: DKMS version is too old and %{module_name} was not"
        echo -e "[Upgrade] built with legacy DKMS support."
        echo -e "[Upgrade] You must either rebuild %{module_name} with legacy postinst"
        echo -e "[Upgrade] support or upgrade DKMS to a more current version."
        exit 1
else
        echo "Invalid $1 value, neither install nor upgrade, abort!"
        exit 1
fi


%preun
if [ "$1" = "0" ]; then
        echo -e
        echo -e "Uninstall of %{module_name} module (version %{version}) beginning:"
        string=%{module_name}
        rmmod $(echo ${string:0:10})
        rm -rf /lib/firmware/vastai

        dkms remove -m %{module_name} -v %{version} --all --rpm_safe_upgrade
        findResult=$(find /lib/modules -name vastai_pci.ko*)
        if [[ ${findResult} != "" ]]; then
                rm ${findResult}
        else
                echo "file already remove"
        fi
elif [ "$1" = "1" ]; then
        echo "[Upgrade] remove %{module_name}-%{version} in dkms"
        dkms remove -m %{module_name} -v %{version} --all --rpm_safe_upgrade
else
        echo "Invalid $1 value, neither install nor upgrade, abort!"
        exit 1
fi


%files
%defattr(-,root,root)
%{_srcdir}
%{_datarootdir}/%{module_name}/

%changelog
* %(date "+%a %b %d %Y") %packager %{version}-%{release}
- Automatic build by DKMS

