/*
 * vastai_pci - driver a Vastai PCI device
 * Copyright (C) 2021 Vastai Technologies All Rights Reserved.
 * This work is licensed under the terms of the GNU GPL, version 2.
 *
 * Create on: 2023/02/02
 * Author: vincent.huang
 */

#ifndef __VASTAI_COMMON_PCI_API_H__
#define __VASTAI_COMMON_PCI_API_H__


enum VASTAI_PCIE_SUBCMD {
	VASTAI_PCIE_SUB_RESET, /* send msg_irq to triger dev reset */
	VASTAI_PCIE_SUB_HANG_SMCU, /* hang smcu timer of feed wdg for test heartbeat*/
	VASTAI_PCIE_SUB_HANG_SMCU_THREAD, /* hang smcu thread for test heartbeat*/
	VASTAI_PCIE_SUB_OPEN_DMA_CALLBACK, /* open smcu dma callback function */
	VASTAI_PCIE_SUB_CLOSE_DMA_CALLBACK, /* close smcu dma callback function */
	VASTAI_PCIE_SUB_FLASH_XSPI, /* send msg_irq to flash xspi */
	VASTAI_PCIE_SUB_READ_XSPI, /* send msg_irq to read xspi */
	VASTAI_PCIE_SUB_SET_BAR, /* set bar address translation */
	VASTAI_PCIE_SUB_CEDAR_SYM_ALG, /* cedar synchronization test */
	VASTAI_PCIE_SUB_CEDAR_ASYM_ALG, /* cedar asynchronization test */
	VASTAI_PCIE_SUB_POWERON, /* power on video module */
	VASTAI_PCIE_SUB_CEDAR_SVC, /* cedar svc */
	VASTAI_PCIE_SUB_BMCU_UPGRADE, /* upgrade BMCU */
	VASTAI_PCIE_SUB_BMCU_DEGRADE, /* degrade BMCU */
	VASTAI_PCIE_SUB_FLASH_BMCU, /* flash BMCU by PCIE port */
	VASTAI_PCIE_SUB_POWEROFF, /* power off video module */
	VASTAI_PCIE_SUB_MSI_TEST, /* a test command */
	VASTAI_PCIE_SUB_DMI_FLASH, /* flash dmi info */
	VASTAI_PCIE_SUB_TIME_SYNC, /* timer sync */
	VASTAI_PCIE_SUB_AI_SYS_RESET, /* reset ai system by PCIE cmd */
	VASTAI_PCIE_SUB_CORE_RESET, /* reset core cmd */
	VASTAI_PCIE_SUB_TRI_EXP_TEST, /* trigger exception test */
	VASTAI_PCIE_SUB_SET_MACHINE_STATE, /* set smcu machine_state */
	VASTAI_PCIE_SUB_REQUEST_BMCU_POWEROFF, /* request bmcu to power off soc */
	VASTAI_PCIE_SUB_FLASH_BASE_XSPI, /* send msg_irq to flash base full xspi */
	VASTAI_PCIE_SUB_READ_BASE_XSPI, /* send msg_irq to read base full xspi */
	VASTAI_PCIE_SUB_FLAG_BASE_XSPI, /* send msg_irq to update base full xspi flag */
	VASTAI_PCIE_SUB_FLAG_XSPI, /* send msg_irq to update xspi flag */
	VASTAI_PCIE_SUB_FLASH_WPEN, /* send msg_irq to enable flash write protect */
	VASTAI_PCIE_SUB_FLASH_WPDIS, /* send msg_irq to disable flash write protect */
	VASTAI_PCIE_SUB_SET_BBOX, /* host set bbox */
	VASTAI_PCIE_SUB_ENABLE_HB, /*enable heartbeat check*/
	VASTAI_PCIE_SUB_DISABLE_HB, /*disable heartbeat check*/
	VASTAI_PCIE_SUB_GET_DLC_CORE, /* send msg_irq to get dlc cores info */
	VASTAI_PCIE_SUB_ACTIVATE_VF, /* activate VF */
	VASTAI_PCIE_SUB_DEACTIVATE_VF, /* deactivate VF */
	VASTAI_PCIE_SUB_CONFIG_VF_MSIX_ATU, /* config die0 ep ob region for vf msix */
	VASTAI_PCIE_SUB_BAR2_ATU, /* set bar2 ATU */
	VASTAI_PCIE_SUB_BAR4_ATU, /* set bar4 ATU */
};

#endif /* end of __VASTAI_COMMON_PCI_API_H__ */
