#ifndef _DDR_PARTITION_H
#define _DDR_PARTITION_H

#define DDR_BASE_ADDR 0x800000000

/* MCU, DSP CODE AREA TOTAL 256M Bytes*/
#define SMCU_CODE_BASE (DDR_BASE_ADDR + 0x00000000) //size 4M
#define CMCU_CODE_BASE (DDR_BASE_ADDR + 0x00400000) //size 4M

#define LMCU0_CODE_BASE (DDR_BASE_ADDR + 0x00800000) //size 4M
#define LMCU1_CODE_BASE (DDR_BASE_ADDR + 0x00c00000) //size 4M
#define LMCU2_CODE_BASE (DDR_BASE_ADDR + 0x01000000) //size 4M
#define LMCU3_CODE_BASE (DDR_BASE_ADDR + 0x01400000) //size 4M
#define LMCU4_CODE_BASE (DDR_BASE_ADDR + 0x01800000) //size 4M
#define LMCU5_CODE_BASE (DDR_BASE_ADDR + 0x01C00000) //size 4M
#define LMCU6_CODE_BASE (DDR_BASE_ADDR + 0x02000000) //size 4M
#define LMCU7_CODE_BASE (DDR_BASE_ADDR + 0x02400000) //size 4M

#define ODSP0_CODE_BASE	     (DDR_BASE_ADDR + 0x02800000) //size 8M
#define ODSP1_CODE_BASE	     (DDR_BASE_ADDR + 0x03000000) //size 8M
#define ODSP2_CODE_BASE	     (DDR_BASE_ADDR + 0x03800000) //size 8M
#define ODSP3_CODE_BASE	     (DDR_BASE_ADDR + 0x04000000) //size 8M
#define ODSP4_CODE_BASE	     (DDR_BASE_ADDR + 0x04800000) //size 8M
#define ODSP5_CODE_BASE	     (DDR_BASE_ADDR + 0x05000000) //size 8M
#define ODSP6_CODE_BASE	     (DDR_BASE_ADDR + 0x05800000) //size 8M
#define ODSP7_CODE_BASE	     (DDR_BASE_ADDR + 0x06000000) //size 8M
#define ODSP_SHARE_DATA_BASE (DDR_BASE_ADDR + 0x06800000) //size 16M

#define VDMCU0_CODE_BASE (DDR_BASE_ADDR + 0x07800000) //size 8M
#define VDMCU1_CODE_BASE (DDR_BASE_ADDR + 0x08000000) //size 8M
#define VDMCU2_CODE_BASE (DDR_BASE_ADDR + 0x08800000) //size 8M

#define VEMCU0_CODE_BASE (DDR_BASE_ADDR + 0x09000000) //size 8M
#define VEMCU1_CODE_BASE (DDR_BASE_ADDR + 0x09800000) //size 8M
#define VEMCU2_CODE_BASE (DDR_BASE_ADDR + 0x0A000000) //size 8M
#define VEMCU3_CODE_BASE (DDR_BASE_ADDR + 0x0A800000) //size 8M

#define VDSP0_CODE_BASE (DDR_BASE_ADDR + 0x0B000000) //size 8M
#define VDSP1_CODE_BASE (DDR_BASE_ADDR + 0x0B800000) //size 8M
#define VDSP2_CODE_BASE (DDR_BASE_ADDR + 0x0C000000) //size 8M
#define VDSP3_CODE_BASE (DDR_BASE_ADDR + 0x0C800000) //size 8M

#define DECODER_CMD_BUF_BASE (DDR_BASE_ADDR + 0x0D000000) //size 32M

#define CODE_RESERVER_BASE (DDR_BASE_ADDR + 0x0F000000) //size 16M

/* The local share data, include local msg and log buf on ddr, total 64M */
#define LOCAL_SHARE_BASE (DDR_BASE_ADDR + 0x10000000) //size 1M
#define MSG_TO_SMCU	 (LOCAL_SHARE_BASE + 0x00000000) //size 1M
#define MSG_TO_CMCU	 (LOCAL_SHARE_BASE + 0x00100000) //size 1M
#define MSG_TO_LMCU	 (LOCAL_SHARE_BASE + 0x00200000) //size 4M
#define MSG_TO_ODSP	 (LOCAL_SHARE_BASE + 0x00600000) //size 4M
#define MSG_TO_VDMCU	 (LOCAL_SHARE_BASE + 0x00A00000) //size 4M
#define MSG_TO_VEMUC	 (LOCAL_SHARE_BASE + 0x00E00000) //size 4M
#define MSG_TO_VDSP	 (LOCAL_SHARE_BASE + 0x01200000) //size 4M

#define MSG_TO_AI_CSR_BASE (LOCAL_SHARE_BASE + 0x01600000) //size 13M

/* All MCUS DSPS log store to this memory, Total size is 29M,
 * each core's log buf is 1M Bytes.
 */
#define LOG_BUF_BASE  (LOCAL_SHARE_BASE + 0x02300000)
#define SMCU_LOG_BASE (LOG_BUF_BASE + 0x00000000)
#define CMCU_LOG_BASE (LOG_BUF_BASE + 0x00100000)

#define LMCU0_LOG_BASE (LOG_BUF_BASE + 0x00200000)
#define LMCU1_LOG_BASE (LOG_BUF_BASE + 0x00300000)
#define LMCU2_LOG_BASE (LOG_BUF_BASE + 0x00400000)
#define LMCU3_LOG_BASE (LOG_BUF_BASE + 0x00500000)
#define LMCU4_LOG_BASE (LOG_BUF_BASE + 0x00600000)
#define LMCU5_LOG_BASE (LOG_BUF_BASE + 0x00700000)
#define LMCU6_LOG_BASE (LOG_BUF_BASE + 0x00800000)
#define LMCU7_LOG_BASE (LOG_BUF_BASE + 0x00900000)

#define ODSP0_LOG_BASE (LOG_BUF_BASE + 0x00A00000)
#define ODSP1_LOG_BASE (LOG_BUF_BASE + 0x00B00000)
#define ODSP2_LOG_BASE (LOG_BUF_BASE + 0x00C00000)
#define ODSP3_LOG_BASE (LOG_BUF_BASE + 0x00D00000)
#define ODSP4_LOG_BASE (LOG_BUF_BASE + 0x00E00000)
#define ODSP5_LOG_BASE (LOG_BUF_BASE + 0x00F00000)
#define ODSP6_LOG_BASE (LOG_BUF_BASE + 0x01000000)
#define ODSP7_LOG_BASE (LOG_BUF_BASE + 0x01100000)

#define VDMCU0_LOG_BASE (LOG_BUF_BASE + 0x01200000)
#define VDMCU1_LOG_BASE (LOG_BUF_BASE + 0x01300000)
#define VDMCU2_LOG_BASE (LOG_BUF_BASE + 0x01400000)

#define VEMCU0_LOG_BASE (LOG_BUF_BASE + 0x01500000)
#define VEMCU1_LOG_BASE (LOG_BUF_BASE + 0x01600000)
#define VEMCU2_LOG_BASE (LOG_BUF_BASE + 0x01700000)
#define VEMCU3_LOG_BASE (LOG_BUF_BASE + 0x01800000)

#define VDSP0_LOG_BASE (LOG_BUF_BASE + 0x01900000)
#define VDSP1_LOG_BASE (LOG_BUF_BASE + 0x01A00000)
#define VDSP2_LOG_BASE (LOG_BUF_BASE + 0x01B00000)
#define VDSP3_LOG_BASE (LOG_BUF_BASE + 0x01C00000)

/* Include pcie dma config, chn info, moduel info and sr-iov reserved.
 * This is a backup for csram space not enough.
 *  2M * 4die = 64M
 */
#define SHARE_TO_HOST_BASE (DDR_BASE_ADDR + 0x14000000)
#define ENCODER_DATA_BASE  (SHARE_TO_HOST_BASE + 0x00000000) //size 16M
#define DECODER_DATA_BASE  (SHARE_TO_HOST_BASE + 0x01000000) //size 1M
#define ECC_1BIT_BUF	   (SHARE_TO_HOST_BASE + 0x01100000)
#define ECC_2BIT_BUF	   (SHARE_TO_HOST_BASE + 0x01200000)
#define SR_IOV_BASE_ADDR   (SHARE_TO_HOST_BASE + 0x01300000) // size 13M

/* The partition is a temporay allocation, Total 736M,
 * subsequent encoders need to optimize the heap size. 
 */
#define ENCODER_HEAP_BASE (DDR_BASE_ADDR + 0x16000000)
#define ENCODER_RESERVED  (ENCODER_HEAP_BASE + 0x00000000) //size 32M
#define ENCODER_CMD_BUF	  (ENCODER_HEAP_BASE + 0x02000000) //size 64M
#define VEMCU0_HEAP_BASE  (ENCODER_HEAP_BASE + 0x06000000) //size 160M
#define VEMCU1_HEAP_BASE  (ENCODER_HEAP_BASE + 0x10000000) //size 160M
#define VEMCU2_HEAP_BASE  (ENCODER_HEAP_BASE + 0x1A000000) //size 160M
#define VEMCU3_HEAP_BASE  (ENCODER_HEAP_BASE + 0x24000000) //size 160M

#define DDR_DYNAMIC_ALLOC_BASE (DDR_BASE_ADDR + 0x44000000)
#define DDR_DYNAMIC_ALLOC_FRONT_BASE DDR_DYNAMIC_ALLOC_BASE
#define DDR_BOOT_FW_BASE             (DDR_BASE_ADDR + 0x80000000)
#define DDR_DYNAMIC_ALLOC_INTER_BASE (DDR_BASE_ADDR + 0x80100000)
#define DDR_RESET_VECTOR_BASE        (DDR_BASE_ADDR + 0xC0000000)
#define DDR_DYNAMIC_ALLOC_BACK_BASE  (DDR_BASE_ADDR + 0xC3000000)

#endif /* _DDR_PARTITION_H */
