/* SPDX-License-Identifier: GPL-2.0 */
/*
 *    Vastai driver hardware register definition.
 *
 *    Copyright (c) 2017,VASTAI Inc.
 *
 *    This program is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU General Public License
 *    as published by the Free Software Foundation; either version 2
 *    of the License, or (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You may obtain a copy of the GNU General Public License
 *    Version 2 or later at the following locations:
 *    http://www.opensource.org/licenses/gpl-license.html
 *    http://www.gnu.org/copyleft/gpl.html
 */

#ifndef __DWL_DEFS_H__
#define __DWL_DEFS_H__

#define DWL_MPEG2_E		31 /* 1 bit  */
#define DWL_VC1_E		29 /* 2 bits */
#define DWL_JPEG_E		28 /* 1 bit  */
#define DWL_HJPEG_E      17 /* 1 bit  */
#define DWL_MPEG4_E		26 /* 2 bits */
#define DWL_H264_E		24 /* 2 bits */
#define DWL_H264HIGH10_E	20 /* 1 bits */
#define DWL_AVS2_E       18 /* 2 bits */
#define DWL_VP6_E		23 /* 1 bit  */
#define DWL_RV_E		26 /* 2 bits */
#define DWL_VP8_E		23 /* 1 bit  */
#define DWL_VP7_E		24 /* 1 bit  */
#define DWL_WEBP_E		19 /* 1 bit  */
#define DWL_AVS_E		22 /* 1 bit  */
#define DWL_G1_PP_E		16 /* 1 bit  */
#define DWL_G2_PP_E		31 /* 1 bit  */
#define DWL_PP_E		31 /* 1 bit  */
#define DWL_HEVC_E		26 /* 3 bits */
#define DWL_VP9_E		29 /* 3 bits */

#define DWL_H264_PIPELINE_E	31 /* 1 bit */
#define DWL_JPEG_PIPELINE_E	30 /* 1 bit */

#define DWL_G2_HEVC_E		0 /* 1 bits */
#define DWL_G2_VP9_E		1 /* 1 bits */
#define DWL_G2_RFC_E		2 /* 1 bits */
#define DWL_RFC_E		17 /* 2 bits */
#define DWL_G2_DS_E		3 /* 1 bits */
#define DWL_DS_E		28 /* 3 bits */
#define DWL_HEVC_VER		8 /* 4 bits */
#define DWL_VP9_PROFILE		12 /* 3 bits */
#define DWL_RING_E		16 /* 1 bits */

#define VASTAIDEC_IRQ_STAT_DEC		1
#define VASTAIDEC_IRQ_STAT_DEC_OFF	(VASTAIDEC_IRQ_STAT_DEC * 4)
#define BIGOCEAN_IRQ_STAT_DEC       2
#define BIGOCEAN_IRQ_STAT_DEC_OFF   (VASTAIDEC_IRQ_STAT_DEC * 4)

#define VASTAIDECPP_SYNTH_CFG		60
#define VASTAIDECPP_SYNTH_CFG_OFF	(VASTAIDECPP_SYNTH_CFG * 4)
#define VASTAIDEC_SYNTH_CFG		50
#define VASTAIDEC_SYNTH_CFG_OFF		(VASTAIDEC_SYNTH_CFG * 4)
#define VASTAIDEC_SYNTH_CFG_2		54
#define VASTAIDEC_SYNTH_CFG_2_OFF	(VASTAIDEC_SYNTH_CFG_2 * 4)
#define VASTAIDEC_SYNTH_CFG_3		56
#define VASTAIDEC_SYNTH_CFG_3_OFF	(VASTAIDEC_SYNTH_CFG_3 * 4)
#define VASTAIDEC_CFG_STAT		23
#define VASTAIDEC_CFG_STAT_OFF		(VASTAIDEC_CFG_STAT * 4)
#define VASTAIDECPP_CFG_STAT		260
#define VASTAIDECPP_CFG_STAT_OFF	(VASTAIDECPP_CFG_STAT * 4)
/* VC8000D HW build id */
#define VASTAIDEC_HW_BUILD_ID		309
#define VASTAIDEC_HW_BUILD_ID_OFF	(VASTAIDEC_HW_BUILD_ID * 4)

#define VASTAIDEC_DEC_E			0x01
#define VASTAIDEC_PP_E			0x01
#define VASTAIDEC_DEC_ABORT		0x20
#define VASTAIDEC_DEC_IRQ_DISABLE	0x10
#define VASTAIDEC_DEC_IRQ		0x100

/* Legacy from G1 */
#define VASTAI_IRQ_STAT_DEC		1
#define VASTAI_IRQ_STAT_DEC_OFF		(VASTAI_IRQ_STAT_DEC * 4)
#define VASTAI_IRQ_STAT_PP		60
#define VASTAI_IRQ_STAT_PP_OFF		(VASTAI_IRQ_STAT_PP * 4)

#define VASTAIPP_SYNTH_CFG		100
#define VASTAIPP_SYNTH_CFG_OFF		(VASTAIPP_SYNTH_CFG * 4)
#define VASTAIDEC_SYNTH_CFG		50
#define VASTAIDEC_SYNTH_CFG_OFF		(VASTAIDEC_SYNTH_CFG * 4)
#define VASTAIDEC_SYNTH_CFG_2		54
#define VASTAIDEC_SYNTH_CFG_2_OFF	(VASTAIDEC_SYNTH_CFG_2 * 4)

#define VASTAI_DEC_E			0x01
#define VASTAI_PP_E			0x01
#define VASTAI_DEC_ABORT		0x20
#define VASTAI_DEC_IRQ_DISABLE		0x10
#define VASTAI_PP_IRQ_DISABLE		0x10
#define VASTAI_DEC_IRQ			0x100
#define VASTAI_PP_IRQ			0x100

#endif /* __DWL_DEFS_H__ */
